//////////////////////////////////////////////////////////////////////
/*****************************************************************/
// This file is a part of the E-Form++ MFC Extention Class.
// 2001-200? ucancode.com Software, All Rights Reserved.
// This is only define for UCanCode Software E-Form++ Library.
//
// UCanCode SOFTWARE GRANTS TO YOU (ONE SOFTWARE PROGRAMMER) THE
// LIMITED RIGHT TO USE THIS SOFTWARE ON A SINGLE COMPUTER.  
//  THESE SOURCE FILE ARE CONSIDERED CONFIDENTIONAL AND ARE 
// THE PROPERTY OF UCanCode SOFTWARE AND ARE NOT TO BE RE-DISTRIBUTED
// BY ANY MEANS WHATSOEVER WITHOUT THE EXPRESSED WRITTEN CONSENT OF 
// UCanCode SOFTWARE.
//
// You can contact us.
// Support@ucancode.com
// http://www.ucancode.com
/********************************************************************/
#if !defined(FO_FOPCLOUDSHAPE_H__C5D52DE6_EAB2_4DAA_8DA1_EAC3BCCDE881__INCLUDED_)
#define FO_FOPCLOUDSHAPE_H__C5D52DE6_EAB2_4DAA_8DA1_EAC3BCCDE881__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


//------------------------------------------------------
// Description
// Author: Author Name.
//------------------------------------------------------
#include "FOPUtil.h"
#include "FODrawPortsShape.h"

struct FOPBezPoint 
{
  FOPPoint p1;
  FOPPoint p2;
  FOPPoint p3;
};

class FO_EXT_CLASS CFOPCloudShape : public CFODrawPortsShape  
{
protected:
	DECLARE_SERIAL(CFOPCloudShape);
public:

	// constructor
	CFOPCloudShape();

	// Copy constructor.
	CFOPCloudShape(const CFOPCloudShape& src);

	// Destructor.
	virtual ~CFOPCloudShape();

	// Creates the button Shape from a CRect object.
	virtual void Create(CRect &rcPos,CString strCaption = "");

	// Compute cloud points.
	void ComputeCloud(const FOPRect &rcPos, FOPBezPoint* bpl);

public:

	// Assignment operator.
	CFOPCloudShape& operator=(const CFOPCloudShape& src);

	// Creates a copy of this Shape.
	virtual CFODrawShape* Copy() const;

	// Update shape's area.
	virtual void GeometryUpdated(CFOArea* pRgn);

	// Obtain the composite of the shape.
	virtual void GetPathSimplePolygon(FOPSimpleCompositePolygon& rPoly) const;

	// Do convert shape to poly or path shape.
	// After you call this method,you must call pObj->Release();
	// bBezier -- if you want to convert it to bezier shape,this will be TRUE.
	virtual CFODrawShape* DoConvertToPathObj(CDC *pDC,const BOOL &bBezier);

	// Dot track
	virtual void DrawDotBorder(CDC* pDC);

	// Get border area.
	virtual CFOArea GetBorderArea();

public:

	// Serializes the data.
	virtual void Serialize(CArchive &ar);
	
	// Save document.
	virtual BOOL SaveDocument(LPCTSTR lpszPathName);

	// Open document.
	virtual BOOL OpenDocument(LPCTSTR lpszPathName);
	
	// Get file.
	CFile *GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,CFileException* pError);
	
	// Release file.
	virtual void ReleaseFile(CFile* pFile, BOOL bAbort);

public:

	//Draw flat status.
	// Draws custom tracker.
	virtual void OnDrawTrackCustom(CDC *pDC);

	// Do draw visio like bounding selection line.
	// pDC -- pointer of the DC.
	virtual void DoDrawVisioOrderLine(CDC *pDC);

	// Creates GDI objects and sets up the device context for drawing. 
	virtual void PrepareDC(CDC* pDC);

	// Draws the flat status of the Shape.
	virtual void OnDrawFlat(CDC *pDC);

	// Draws shadow of Shape.
	virtual void OnDrawShadow(CDC *pDC);

	// Draws the 3D status of the Shape.
	virtual void OnDraw3d(CDC *pDC);

	// Frees GDI objects and restores the state of the device context.
	virtual void ClearDC(CDC* pDC);
	// Implementation

public:

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};



#endif // !defined(FO_FOPCLOUDSHAPE_H__C5D52DE6_EAB2_4DAA_8DA1_EAC3BCCDE881__INCLUDED_)
